// juego.c
// Esqueleto de juegos de Radastan para ZX Spectrum
// version 0.1 beta

#include <sprites.h>
#include <tiles.h>
#include <tiles_bordes.h>
#include <menu.h>
#include <final.h>
#include <numeros.h>
#include <lib\motorzxuno.h>
#include <lib\ascii.h>
#include <lib\sonidos.h>
#include <mapa.h>
#include <marco.h>
#include <paleta.h>

extern unsigned char pantalla [768] @ 48000;
extern unsigned char anim @ 47999;
extern unsigned char rayost @ 47998;
extern unsigned char x @ 47997; // Posicin personaje
extern unsigned char y @ 47996;
extern unsigned char ux @ 47995; // Posicin personaje al entrar en una pantalla
extern unsigned char uy @ 47994;
extern unsigned char vidas @ 47993;
extern unsigned char ene1_dir @ 47992;
extern unsigned char ene2_dir @ 47991;
extern unsigned char anime @ 47990;
extern unsigned char ene1_x @ 47989;
extern unsigned char ene1_y @ 47988;
extern unsigned char ene2_x @ 47987;
extern unsigned char ene2_y @ 47986;
extern unsigned int sala @ 47982;
extern unsigned char izquierda @ 47981;
extern unsigned char frame @ 47980;
extern unsigned char recoger @ 47979;
extern unsigned char llaves @ 47978;
extern unsigned char mapa_joyas [48] @ 47930;
extern unsigned int sala2 @ 47926;
extern unsigned int sala3 @ 47922;
extern unsigned char ene1_spr @ 47921;
extern unsigned char ene2_spr @ 47920;
extern unsigned char arriba_o_abajo @ 47919;
extern unsigned char hojas @ 47918;


// PARA GENERAR CARTUCHO:
// pantalla comienza en 30000 y las variables de 29999 hacia abajo

// PARA GENERAR CINTA:
// pantalla comienza en 48000 y las variables de 47999 hacia abajo

void main (void)
{
	unsigned char a;
	port_out (254,0); // Ponemos el borde de color negro

	// Inicializamos el modo Radastaniano
	port_out (64571,64);
	port_out (64827,3);
	
	// Definimos la paleta
	for (a=0;a<16;++a)
	{
		escribe_paleta (a,paleta[a]);
	}
	cls (0);

	while (1)
	{
		menu();
		juego();
		game_over();
	}
}

signed int juego ()
{
	anim=0;
	anime=0;
	frame=0;
	izquierda=0;
	x=36;
	y=56;
	sala=41;
	vidas=3;
	hojas=0;
	llaves=0;
	crea_mapa_objetos(42, 80); // total de salas, tiles por sala
	cls (0); // Borramos la pantalla
	dibuja_marcador();
	actualiza_marcador();
	dibuja_mapa(sala,12,16,20,80); // sala,x,y,ancho caracteres,tiles por sala
	get_sprite_x8 (sprite_fondo,x,y);
	put_msprite_x8 (sprite_prota_derecha1, x, y);
	while (vidas>0 && hojas<5)
	{
		mueve_prota(); // incluye wait_int()
		// Cambiamos en el escenario los tiles animados
		wait_int();
		anima_enemigos();
		detecta_colisiones();
		wait_int();
		anima_mapa(12,16,20,80); //x,y,ancho caracteres,tiles por sala
	}
	if (hojas==5) final ();
}

signed int final ()
{
	unsigned char z2;
	cls(0);
	x=8;
	y=8;
	for (z2=0;z2<96;++z2)
	{
		put_sprite_x8 (tiles+mapa_final[z2]*32, x, y);
		x=x+4;
		if (x==56)
		{
			x=8;
			y=y+8;
		}
	}
	put_sprite_x8 (sprite_prota_izquierda1, 40, 40);
	print ("WELL DONE!!",6,82);
	print ("NOW, YOU CAN BE A MAGICIAN",6,90);
	z2=1;
	while(z2)
	{
		if ((port_in(32766)&1)==0 || (port_in(63486)&16)==0) z2=0; // Tecla de espacio
	}
	wait_int();
	wait_int();
	wait_int();
	wait_int();

}

signed int borra_prota()
{
	put_sprite_x8 (sprite_fondo,x,y);
}

signed int mueve_prota ()
{
	unsigned char z,mx,my, tx, ty;
	z=0;
	mx=x;
	my=y;
	tx=x/2;
	ty=y/4;
			if (((port_in(64510)&1)==0 || (port_in(63486)&8)==0) && pantalla[tx+((ty-1)*32)]<7 && pantalla[tx+1+((ty-1)*32)]<7) // Q
		{
			z=1;
			my=my-4;
			arriba_o_abajo=1;
			--ty;
		}
		if (((port_in(65022)&1)==0 || (port_in(63486)&4)==0) && pantalla[tx+((ty+2)*32)]<7 && pantalla[tx+1+((ty+2)*32)]<7) // A
		{
			z=1;
			my=my+4;
			arriba_o_abajo=0;
			++ty;
		}
		if (((port_in(57342)&1)==0 || (port_in(63486)&2)==0) && pantalla[tx+2+(ty*32)]<7 && pantalla[tx+2+((ty+1)*32)]<7) // P
		{
			z=1;
			mx=mx+2;
			izquierda=0;
		}
		if (((port_in(57342)&2)==0 || (port_in(63486)&1)==0) && pantalla[tx-1+(ty*32)]<7 && pantalla[tx-1+((ty+1)*32)]<7) // O
		{
			z=1;
			mx=mx-2;
			izquierda=1;
		}
		// Cambiamos de pantalla si corresponde
		if (mx>48) // Derecha
		{
			x=12;
			mx=12;
			++sala;
			dibuja_mapa(sala,12,16,20,80); // sala,x,y,ancho caracteres,tiles por sala
			ux=x;
			uy=my;
			z=1;
		}
		if (mx<12) // Izquierda
		{
			x=48;
			mx=48;
			--sala;
			dibuja_mapa(sala,12,16,20,80); // sala,x,y,ancho caracteres,tiles por sala
			ux=x;
			uy=my;
			z=1;
		}
		if (my<16) // Arriba
		{
			y=72;
			my=72;
			sala=sala-7;
			dibuja_mapa(sala,12,16,20,80); // sala,x,y,ancho caracteres,tiles por sala
			ux=mx;
			uy=y;
			z=1;
		}
		if (my>72) // Abajo
		{
			y=16;
			my=16;
			sala=sala+7;
			dibuja_mapa(sala,12,16,20,80); // sala,x,y,ancho caracteres,tiles por sala
			ux=mx;
			uy=y;
			z=1;
		}
		
		// Imprimimos el personaje
		wait_int(); // As evitamos parpadeo al mover
		if (z)
		{
			borra_prota();
			x=mx;
			y=my;
			get_sprite_x8 (sprite_fondo,x,y);
			if (frame<2)
			{
				dibuja_prota();
				++frame;
				sonido_andar1();
			}
			else
			{
				if (izquierda==0) put_msprite_x8 (sprite_prota_derecha2, x, y);
				else put_msprite_x8 (sprite_prota_izquierda2, x, y);
			    ++frame;
				sonido_andar2();
			}
			if (frame==4) frame=0;
			z=0;
		}
}

signed int game_over ()
{
	unsigned char a;
	cls (0);
	put_sprite_x8 (tiles+1632, 16, 44);
	put_sprite_x8 (tiles+1632, 46, 44);
	print ("GAME OVER",24,46);
	for (a=0;a<10;++a)
	{
		port_out (254,18); // Borde color rojo
		port_out (254,18); // Borde color rojo
		wait_int();
		port_out (254,0); // Borde color negro
		port_out (254,0); // Borde color negro
		wait_int();
	}
	a=1;
	while(a)
	{
		if ((port_in(32766)&1)==0 || (port_in(63486)&16)==0) a=0; // Tecla de espacio
	}
	wait_int();
	wait_int();
	wait_int();
	wait_int();
	cls (0);
}

signed int muerte ()
{
	unsigned char a;
	for (a=0;a<5;++a)
	{
		port_out (254,20); // Borde color verde
		wait_int();
		port_out (254,0); // Borde color negro
		wait_int();
	}
	x=ux;
	y=uy;
	--vidas;
	if (vidas>0)
	{
		dibuja_mapa(sala,12,16,20,80);
		actualiza_marcador();
	}
}

signed int detecta_colisiones ()
{
	unsigned char lee1, lee2, lee3, lee4, nx, ny;
	nx=x/2;
	ny=y/4;
	lee1=pantalla[nx+(ny*32)];
	lee2=pantalla[nx+(32+ny*32)];
	lee3=pantalla[nx+1+(ny*32)];
	lee4=pantalla[nx+1+(32+ny*32)];		
	if (lee1==2 && lee2==2 && lee3==2 && lee4==2) puerta();
	if (lee1==4 || lee2==4 || lee3==4 || lee4==4) muerte();
	if (lee1==5 || lee2==5 || lee3==5 || lee4==5) muerte();
	if (mapa_joyas[sala]==6 && (lee1==6 || lee2==6 || lee3==6 || lee4==6)) recoger_llaves();
	if (mapa_joyas[sala]==3 && (lee1==3 || lee2==3 || lee3==3 || lee4==3)) recoger_hojas();
}

signed int recoger_hojas ()
{
	sonido_rayos();
	mapa_joyas[sala]=33;
	++hojas;
	dibuja_mapa(sala,12,16,20,80);
	get_sprite_x8 (sprite_fondo,x,y);
	actualiza_marcador();
	dibuja_prota();
}

signed int recoger_llaves ()
{
	sonido_rayos();
	mapa_joyas[sala]=66;
	++llaves;
	dibuja_mapa(sala,12,16,20,80);
	get_sprite_x8 (sprite_fondo,x,y);
	actualiza_marcador();
	dibuja_prota();
}

signed int crea_mapa_objetos (signed int salas, signed int tiless) // total de salas, tiles por sala
{
	signed int z2, z3, sala, sala22;
	sala22=salas*tiless;
	sala=0;
	for (z3=0;z3<sala22;z3=z3+tiless)
	{
		for (z2=z3;z2<z3+tiless;++z2)
		{
			if (mapa[z2]==48) mapa_joyas[sala]=3;
			if (mapa[z2]==50) mapa_joyas[sala]=6;
			if (mapa[z2]==7) mapa_joyas[sala]=8;
		}
		++sala;
	}
}

signed int anima_mapa (signed int x, signed int y, signed int ancho, signed int tiless)
{
	signed int z2, x2, y2, ancho2;
	x2=x;
	y2=y;
	ancho2=ancho*2;
	for (z2=sala2;z2<sala3;++z2)
	{
		switch (mapa[z2])
		{
			case 52:	if (anim==0) put_sprite_x8 (tiles+1664, x2, y2); else put_sprite_x8 (tiles+1696, x2, y2); break;
			case 53:	if (anim==0) put_sprite_x8 (tiles+1696, x2, y2); else put_sprite_x8 (tiles+1664, x2, y2); break;
			case 54:	if (anim==0) put_sprite_x8 (tiles+1728, x2, y2); else put_sprite_x8 (tiles+1760, x2, y2); break;
			case 55:	if (anim==0) put_sprite_x8 (tiles+1760, x2, y2); else put_sprite_x8 (tiles+1728, x2, y2); break;
			case 56:	if (anim==0) put_sprite_x8 (tiles+1792, x2, y2); else put_sprite_x8 (tiles+1824, x2, y2); break;
			case 57:	if (anim==0) put_sprite_x8 (tiles+1824, x2, y2); else put_sprite_x8 (tiles+1792, x2, y2); break;
			default: break;
		}
		x2=x2+4;
		if (x2==ancho2+x)
		{
			x2=x;
			y2=y2+8;
		}
	}
	++anim;
	if (anim==2) anim=0;
}

signed int anima_enemigos ()
{
	unsigned char e1x, e1y, e2x, e2y;
	// 1 Derecha
	// 2 Arriba
	// 3 izquierda
	// 4 Abajo
	if (ene1_dir>0)
	{
		pantalla [ene1_x+(ene1_y*32)]=0;
		pantalla [ene1_x+1+(ene1_y*32)]=0;
		pantalla [ene1_x+((ene1_y+1)*32)]=0;
		pantalla [ene1_x+1+((ene1_y+1)*32)]=0;
		e1x=ene1_x*2;
		e1y=ene1_y*4;
		put_sprite_x8 (tiles,e1x,e1y);
		switch (ene1_dir)
		{
			case 0: break;
			case 1: if (ene1_x<26 && pantalla[ene1_x+2+(ene1_y*32)]==0)
					{
						++ene1_x;
					}
					else ene1_dir=3; break;
			case 2:	if (ene1_y>4 && pantalla[ene1_x+((ene1_y-1)*32)]==0)
					{
						--ene1_y;
					}		
					else ene1_dir=4; break;					
			case 3: if (ene1_x>4 && pantalla[ene1_x-1+(ene1_y*32)]==0)
					{
						--ene1_x;
					}
					else ene1_dir=1; break;
			case 4:	if (ene1_y<18 && pantalla[ene1_x+((ene1_y+2)*32)]==0)
					{
						++ene1_y;
					}
					else ene1_dir=2; break;
		}
		e1x=ene1_x*2;
		e1y=ene1_y*4;
		if (anime==0) put_sprite_x8 (tiles+(ene1_spr*32), e1x, e1y); else put_sprite_x8 (tiles+((ene1_spr+1)*32), e1x, e1y);
		pantalla [ene1_x+(ene1_y*32)]=4;
		pantalla [ene1_x+1+(ene1_y*32)]=4;
		pantalla [ene1_x+((ene1_y+1)*32)]=4;
		pantalla [ene1_x+1+((ene1_y+1)*32)]=4;
	}
	if (ene2_dir>0)
	{
		pantalla [ene2_x+(ene2_y*32)]=0;
		pantalla [ene2_x+1+(ene2_y*32)]=0;
		pantalla [ene2_x+((ene2_y+1)*32)]=0;
		pantalla [ene2_x+1+((ene2_y+1)*32)]=0;
		e2x=ene2_x*2;
		e2y=ene2_y*4;
		put_sprite_x8 (tiles,e2x,e2y);
		switch (ene2_dir)
		{
			case 0: break;
			case 1: if (ene2_x<26 && pantalla[ene2_x+2+(ene2_y*32)]==0)
					{
						++ene2_x;
					}
					else ene2_dir=3; break;
			case 2:	if (ene2_y>4 && pantalla[ene2_x+((ene2_y-1)*32)]==0)
					{
						--ene2_y;
					}		
					else ene2_dir=4; break;					
			case 3: if (ene2_x>4 && pantalla[ene2_x-1+(ene2_y*32)]==0)
					{
						--ene2_x;
					}
					else ene2_dir=1; break;
			case 4:	if (ene2_y<18 && pantalla[ene2_x+((ene2_y+2)*32)]==0)
					{
						++ene2_y;
					}
					else ene2_dir=2; break;
		}
		e2x=ene2_x*2;
		e2y=ene2_y*4;
		if (anime==0) put_sprite_x8 (tiles+(ene2_spr*32), e2x, e2y); else put_sprite_x8 (tiles+((ene2_spr+1)*32), e2x, e2y);
		pantalla [ene2_x+(ene2_y*32)]=5;
		pantalla [ene2_x+1+(ene2_y*32)]=5;
		pantalla [ene2_x+((ene2_y+1)*32)]=5;
		pantalla [ene2_x+1+((ene2_y+1)*32)]=5;
	}
	++anime;
	if (anime==2) anime=0;
}

signed int dibuja_mapa (signed int sala, signed int x, signed int y, signed int ancho, signed int tiless)
{
	signed int z2, x2, y2, frame2, enemigos, cal1,cal2, ancho2;
	unsigned int direccion;
	unsigned char tile, puerta_cerrada;
	x2=x/2;
	y2=y/4;
	sala2=sala*tiless;
	sala3=sala2+tiless;
	enemigos=0;
	ene1_dir=0;
	ene2_dir=0;
	ene1_x=0;
	ene1_y=0;
	ene2_x=0;
	ene2_y=0;
	if (mapa_joyas[sala]==6 || mapa_joyas[sala]==3)	recoger=1;
	else recoger=0;
	if (mapa_joyas[sala]==8) puerta_cerrada=1;
	else puerta_cerrada=0;
	if (puerta_cerrada==1 && llaves>0)
	{
		puerta_cerrada=0;
		mapa_joyas[sala]=88;
		--llaves;
		//put_char (numeros+8*llaves, 2, 6);
	}
	for (z2=sala2;z2<sala3;++z2)
	{
		// frame = 7 obstculo
		// frame = 0 traspasable
		// frame = 1 traspasable con decorado
		// frame = 2 puerta abierta
		// frame = 8 puerta cerrada (cambia a 88 en el mapa al ser abierta)
		// frame = 4 enemigo 1
		// frame = 5 enemigo 2
		// frame = 6 llave (cambia a 66 en el mapa al ser cogida)
		// frame = 3 pgina (cambia a 33 en el mapa al ser cogida)
		tile=mapa[z2];
		frame2=7;
		if (tile==0) frame2=0;
		if (tile>0 && tile <4) frame2=1;
		if (tile>3 && tile <6) frame2=2;
		//if (tile>5 && tile<48) frame2=7;
		if (tile==7 && puerta_cerrada==0) frame2=2;
		if (tile==48) frame2=recoger*3;
		if (tile==50) frame2=recoger*6;
		//if (tile>51 && tile<58) frame2=7; // tiles animados
		if (tile>57) // Enemigo
		{
			if (enemigos==0)
			{
				frame2=4; // ENEMIGO 1
				if (tile==58 || tile==60 || tile==62) ene1_dir = 1;
				else ene1_dir = 2;
				ene1_x=x2;
				ene1_y=y2;
				if (ene1_dir==1) ene1_spr=tile;
				else  ene1_spr=tile-1;
			}
			else
			{
				frame2=5; // ENEMIGO 2
				if (tile==58 || tile==60 || tile==62) ene2_dir = 3;
				else ene2_dir = 4;
				ene2_x=x2;
				ene2_y=y2;
				if (ene2_dir==3) ene2_spr=tile;
				else  ene2_spr=tile-1;
			}
			++enemigos;
		}
		cal1=x2+(y2*32);
		cal2=x2+(y2+1)*32;
		pantalla [cal1]=frame2;
		pantalla [1+cal1]=frame2;
		pantalla [cal2]=frame2;
		pantalla [1+cal2]=frame2;
		++x2;
		++x2;
		if (x2==ancho+(x/2))
		{
			x2=x/2;
			++y2;
			++y2;
		}
	}
	x2=x;
	y2=y;
	ancho2=ancho*2;
	wait_int();
	for (z2=sala2;z2<sala3;++z2)
	{
		direccion=mapa[z2]*32;
		if (recoger==0 && (direccion==1536 || direccion==1600)) put_sprite_x8 (tiles, x2, y2);
			else put_sprite_x8 (tiles+direccion, x2, y2);
		if (direccion==224 && puerta_cerrada==0) put_sprite_x8 (tiles+160, x2, y2);
		x2=x2+4;
		if (x2==ancho2+x)
		{
			x2=x;
			y2=y2+8;
		}
	}
}

signed int puerta (void)
{
	unsigned int busca;
	unsigned char leep;

	if (arriba_o_abajo==1) //arriba
	{
		y=64;
		sala=sala-7;
		dibuja_mapa(sala,12,16,20,80); // sala,x,y,ancho caracteres spectrum,tiles por sala
	}
	else
	{
		sala=sala+7;
		dibuja_mapa(sala,12,16,20,80); // sala,x,y,ancho caracteres spectrum,tiles por sala
		for (busca=4;busca<18;busca=busca+2)
		{
			leep=(pantalla[(x/2)+(busca*32)]);
			if (leep==2) y=(busca*4)+8;
		}
	}
	ux=x;
	uy=y;
	get_sprite_x8 (sprite_fondo,x,y);
	dibuja_prota();
}

signed int dibuja_marcador (void)
{
	signed int x2, y2;
	put_sprite_x8 (tilesbordes, 8, 8);
	put_sprite_x8 (tilesbordes+32, 52, 8);
	put_sprite_x8 (tilesbordes+64, 8, 80);
	put_sprite_x8 (tilesbordes+96, 52, 80);
	for (x2=12;x2<52;x2=x2+8)
	{
		put_sprite_x8 (tilesbordes+128, x2, 8);
		put_sprite_x8 (tilesbordes+160, x2+4, 8);
		put_sprite_x8 (tilesbordes+192, x2, 80);
		put_sprite_x8 (tilesbordes+224, x2+4, 80);
	}
	for (y2=16;y2<72;y2=y2+16)
	{
		put_sprite_x8 (tilesbordes+256, 8, y2);
		put_sprite_x8 (tilesbordes+288, 8, y2+8);
		put_sprite_x8 (tilesbordes+320, 52, y2);
		put_sprite_x8 (tilesbordes+352, 52, y2+8);
	}
	put_sprite_x8 (tiles+1536, 0, 16); // hojas	
	put_sprite_x8 (tiles+1600, 0, 32); // llaves
	put_sprite_x8 (sprite_prota_derecha1, 0, 48); //vidas
}

signed int actualiza_marcador (void)
{
	put_letra (ascii + 192+(hojas*12), 5, 18); // hojas
	put_letra (ascii + 192+(llaves*12), 5, 34); // llaves
	put_letra (ascii + 192+(vidas*12), 5, 50); // vidas
	dibuja_prota();
}

signed int menu (void)
{
	unsigned char a;
	put_screen (menu_scr);
	a=1;
	while(a)
	{
		if ((port_in(32766)&1)==0 || (port_in(63486)&16)==0) a=0; // Tecla de espacio
	}
	cls(0);
}

signed int dibuja_prota (void)
{
	if (izquierda==1) put_msprite_x8 (sprite_prota_izquierda1, x, y);
	else put_msprite_x8 (sprite_prota_derecha1, x, y);
}
